#ifndef __FRAGMENT_H
#define __FRAGMENT_H

#include "dawg.h"
#include "keyword.h"

typedef struct __fragment_cell
{
  keyword_set *keywords; // the set of keywords
  int inf_bound; // inf bound between this fragment and the next one
  int sup_bound; // sup bound between this fragment and the next one
  struct __fragment_cell *previous; // previous fragment
  struct __fragment_cell *next; // next fragment
} fragment_cell;

typedef fragment_cell *fragment;

void reset_fragment(fragment l,node *source);
void print_fragment(fragment l);
/************************************************/
/* the string frag is assumed to be well formed */
/* i.e. it must follow the rule:                */
/* fragment = keyword | keyword(p,q)fragment    */
/************************************************/
fragment compute_fragment(const char *frag);
// the real prototype of the following function is:
// int load_fragment(fragment l,int position,node *source,pattern *pat,pattern_fragment *pat_frag);
// for some reasons, I didn't manage to include "pattern.h" in order to declare missing types
int load_fragment(fragment l,int position,node *source,void *pat,void *pat_frag);
int previous_keyword_occurs(fragment_cell *previous_cell,int start_pos);
void unload_fragment(fragment l);
void clean_fragment(fragment l,int position);

#endif // __FRAGMENT_H
