#include "lists.h"

DEFLIST(struct keyword *,keyword_list) 
DEFLIST(int,int_list)
DEFLIST(struct pattern_fragment *,pattern_fragment_list)

int_list int_list_insert(int n,int_list l)
{
  int_list save_l,old_l;

  save_l=l;

  old_l=NULL;
  while(l != NULL)
    {
      if(n == (l->obj))
	{
	  return save_l;
	}
      else if(n > (l->obj))
	{
	  break;
	}
      old_l=l;
      l=l->next;
    }

  if(old_l == NULL)
    {
      return int_list_cons(n,l);
    }
  else
    {
      old_l->next=int_list_cons(n,l);
      return save_l;
    }
}

int_list int_list_clean(int_list l,int sup_bound)
{
  int_list save_l,old_l;

  save_l=l;

  old_l=NULL;

  while(l != NULL)
    {
      if(l->obj < sup_bound)
	{
	  break;
	}
      old_l=l;
      l=l->next;
    }
  
  if(old_l == NULL)
    {
      delete_int_list(l);
      return empty_int_list();
    }
  else
    {
      old_l->next=empty_int_list();
      delete_int_list(l);
      return save_l;
    }
}

int is_element_in_bound(int_list l,int inf_bound,int sup_bound)
{
  int n;

#ifdef SEMI_BOUNDED
  if(inf_bound < 0)
    {    
      while(!is_empty_int_list(l))
	{
	  n=int_list_car(l);
	  
	  if(n <= sup_bound)
	    {
	      return (0==0);
	    }
	  
	  l=int_list_cdr(l);
	}
    }
  else
    {
#endif
      while(!is_empty_int_list(l))
	{
	  n=int_list_car(l);
	  
	  if((n >= inf_bound) && (n <=sup_bound))
	    {
	      return (0==0);
	    }
	  
	  l=int_list_cdr(l);
	}
#ifdef SEMI_BOUNDED
    }
#endif
  return (0==1);
}

void print_int_list(int_list l)
{
  if(is_empty_int_list(l))
    {
      return;
    }
  while(!is_empty_int_list(l))
    {
      fprintf(stdout,"%d ",int_list_car(l));
      l=int_list_cdr(l);
    }
  fprintf(stdout,"\n");
}
