#include <stdio.h>
#include <stdlib.h>
#include "parse_cmdline.h"
#include "defs.h"
#include "match.h"
#include "errors.h"

extern int num_of_pats;
extern int counter_mode;
int counter;

int main(int argc,char *argv[])
{
  FILE *fd;
  int nb_files;
  int i;
  char *filename;
  int res=(0==1);

  nb_files=parse_cmdline(argc,argv,&num_of_pats);

  if(num_of_pats == 0)
    {
      fprintf(stderr,"no pattern found\n");
      exit(NO_PATTERNS);
    }

  if(nb_files <= 0)
    {
      filename=NULL;
      fd=stdin;
      counter=0;
      res=match(fd);
      if((res) && (counter_mode))
	{
	  fprintf(stdout,"%d matche(s).\n",counter);
	}
    }
  else
    {
      for(i=argc-nb_files;i<argc;i++)
	{
	  filename=argv[i];

	  if((fd=fopen(filename,"r")) == NULL)
	    {
	      fprintf(stderr,"unable to open %s\n",filename);
	      // exit(FILE_ERROR);
	      continue;
	    }

#ifdef BUFFER_SIZE
#if (BUFFER_SIZE > BUFSIZ)
	  //  setbuffer(fd,NULL,BUFFER_SIZE > BUFSIZ ? BUFFER_SIZE : BUFSIZ);
	  setbuffer(fd,NULL,BUFFER_SIZE);
#else
#warning "use a higher BUFFER_SIZE"
#endif
#endif

	  fprintf(stdout,"%s:\n",filename);
	  
	  counter=0;
	  if(match(fd))
	    {
	      res=(0==0);
	      if(counter_mode)
		{
		  fprintf(stdout,"%d matche(s).\n",counter);
		}
	    }

	  fclose(fd);
	}
    }

  if(res)
    {
      exit(PATTERN_FOUND);
    }
  else
    {
      exit(NO_FAILURE);
    }
}
