#ifndef __PATTERN_H
#define __PATTERN_H

#include "fragment.h"
#include "lists.h"
#include "dawg.h"

typedef struct 
{
  int occurs; // indicate whether the fragment has occured
  int end_position; // indicate one end-position of an occurrence of the fragment
  fragment fragment; // the fragment
} pattern_fragment;

typedef struct
{
  pattern_fragment_list fragments; // list of the fragments that compose the pattern
  int underloading; // indicate whether the pattern is under loading
  pattern_fragment_list current_fragment; // pointer to the fragment currently under loading
} pattern;

void reset_pattern(pattern *pat,node *source);
void print_pattern(pattern *pat);
void print_pattern_position(pattern *pat);
/***********************************************/
/* pattern_string is assumed to be well formed */
/* it must follow the rules:                   */
/* pattern = fragment | fragment#pattern       */
/***********************************************/
pattern *compute_pattern(const char *pattern_string);
void load_pattern(pattern *pat,int position,node *source);
int pattern_occurs(pattern *pat);

#endif // __PATTERN_H
